hdu 3033 I love sneakers!(分组背包,每组至少取1个)

I love sneakers!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 1094    Accepted Submission(s): 448


Problem Description
After months of hard working, Iserlohn finally wins awesome amount of scholarship. As a great zealot of sneakers, he decides to spend all his money on them in a sneaker store.
hdu 3033 I love sneakers!(分组背包,每组至少取1个)_第1张图片
There are several brands of sneakers that Iserlohn wants to collect, such as Air Jordan and Nike Pro. And each brand has released various products. For the reason that Iserlohn is definitely a sneaker-mania, he desires to buy at least one product for each brand.
Although the fixed price of each product has been labeled, Iserlohn sets values for each of them based on his own tendency. With handsome but limited money, he wants to maximize the total value of the shoes he is going to buy. Obviously, as a collector, he won’t buy the same product twice.
Now, Iserlohn needs you to help him find the best solution of his problem, which means to maximize the total value of the products he can buy.
 

Input
Input contains multiple test cases. Each test case begins with three integers 1<=N<=100 representing the total number of products, 1 <= M<= 10000 the money Iserlohn gets, and 1<=K<=10 representing the sneaker brands. The following N lines each represents a product with three positive integers 1<=a<=k, b and c, 0<=b,c<100000, meaning the brand’s number it belongs, the labeled price, and the value of this product. Process to End Of File.
 

Output
For each test case, print an integer which is the maximum total value of the sneakers that Iserlohn purchases. Print "Impossible" if Iserlohn's demands can’t be satisfied.
 

Sample Input
   
   
   
   
5 10000 3 1 4 6 2 5 7 3 4 99 1 55 77 2 44 66
 

Sample Output
   
   
   
   
255
 

Source
2009 Multi-University Training Contest 13 - Host by HIT
 

Recommend
gaojie
 
题目: http://acm.hdu.edu.cn/showproblem.php?pid=3033
分析:这题一看就是带分组的01背包问题,关键的限制在于每组至少取1个,而不是最多1个,其实只要改变一下循环的顺序,加一个辅助数组来统计就行,不过这题再次出现了物品费用为0 的问题,只要换一下更新值的顺序,辅助数组g[i]用来保存用i的钱去得的最大值,f[i]表示这一组用i的钱至少取一个的最值,每次换组的时候g[i]=f[i],f[i]=0,表示前面那几种的值要保留下来,而新的一组至少取1个的值赋为0。。。由于没有注意会出现0费用,wa了几次,第一次用java做题,好挫啊= =,由于要考java,近期将会用java做题= =
代码:
import java.io.*;
import java.util.*;
public class Main
{
	public static int max(int a,int b)
	{
		return a>b?a:b;
	}
	public static void main(String arg[])
	{
		Scanner cin=new Scanner(System.in);
		int mm=11111;
		int mn=111;
		int oo=-1000000000;
		int a[]=new int[mn],b[]=new int[mn],c[]=new int[mn];
		int f[]=new int[mm],g[]=new int[mm];
		int i,j,n,m,k;
		while(cin.hasNextInt())
		{
			n=cin.nextInt();
			m=cin.nextInt();
			k=cin.nextInt();
			for(i=0;i<n;++i)
			{
				a[i]=cin.nextInt();
				b[i]=cin.nextInt();
				c[i]=cin.nextInt();
			}
			for(i=0;i<n;++i)
				for(j=i;j<n;++j)
					if(a[i]>a[j])
					{
						int tmp;
						tmp=a[i];a[i]=a[j];a[j]=tmp;
						tmp=b[i];b[i]=b[j];b[j]=tmp;
						tmp=c[i];c[i]=c[j];c[j]=tmp;
					}
			for(f[0]=g[0]=0,i=1;i<=m;++i)f[i]=g[i]=oo;
			for(i=0;i<n;++i)
			{
				for(j=m;j>=b[i];--j)
				{
					f[j]=max(f[j],g[j-b[i]]+c[i]);
					g[j]=max(g[j],g[j-b[i]]+c[i]);
				}
				if(a[i]!=a[i+1]&&--k>0)
					for(j=1;j<=m;f[j++]=oo)g[j]=f[j];
			}
			for(i=1;i<m;++i)f[m]=max(f[m],f[i]);
			if(f[m]>0&&k==0)System.out.println(f[m]);
			else System.out.println("Impossible");
		}
	}
}


你可能感兴趣的:(java,c,Integer,import,each,Training)